> ## Documentation Index
> Fetch the complete documentation index at: https://docs.korint.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Push customer custom event.



## OpenAPI

````yaml /openapi.json post /customers/{customerId}/events
openapi: 3.0.0
info:
  title: Korint Documentation
  description: Korint API Documentation
  version: 1.0.0
  contact: {}
servers: []
security:
  - bearerAuth: []
tags: []
paths:
  /customers/{customerId}/events:
    post:
      tags:
        - customer
      summary: Push customer custom event.
      operationId: CustomerController_pushCustomerEvent
      parameters:
        - name: customerId
          required: true
          in: path
          description: the customer id
          schema:
            type: string
        - name: whenAt
          required: false
          in: query
          description: 'Optional: the whenAt datetime'
          schema:
            type: string
        - name: branchId
          required: false
          in: query
          description: 'Optional: the branch id'
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PushCustomerEventInputBody'
      responses:
        '200':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PushCustomerEventOutput'
        '400':
          content:
            application/json:
              schema:
                anyOf:
                  - $ref: '#/components/schemas/InvalidEventTypeErrorDto'
              examples:
                INVALID_EVENT_TYPE:
                  $ref: '#/components/schemas/InvalidEventTypeErrorDto'
          description: ''
        '404':
          content:
            application/json:
              schema:
                anyOf:
                  - $ref: '#/components/schemas/CustomerNotFoundErrorDto'
              examples:
                CUSTOMER_NOT_FOUND:
                  $ref: '#/components/schemas/CustomerNotFoundErrorDto'
          description: ''
components:
  schemas:
    PushCustomerEventInputBody:
      type: object
      properties:
        metadata:
          description: metadata assigned to the object
          type: array
          items:
            $ref: '#/components/schemas/Metadata'
        eventType:
          type: string
          description: The event type
      required:
        - eventType
    PushCustomerEventOutput:
      type: object
      properties: {}
    InvalidEventTypeErrorDto:
      type: object
      properties:
        code:
          type: string
          enum:
            - INVALID_EVENT_TYPE
        message:
          type: string
          example: Event type {eventType} is not in config for product {productId}
        details:
          $ref: '#/components/schemas/InvalidEventTypeDetailsDto'
      required:
        - code
        - message
        - details
    CustomerNotFoundErrorDto:
      type: object
      properties:
        code:
          type: string
          enum:
            - CUSTOMER_NOT_FOUND
        message:
          type: string
          example: Customer {customerId} ({branchId}) not found
        details:
          $ref: '#/components/schemas/CustomerNotFoundDetailsDto'
      required:
        - code
        - message
        - details
    Metadata:
      type: object
      properties:
        key:
          type: string
          description: the key of the metadata
        value:
          type: string
          description: the value of the metadata
      required:
        - key
        - value
    InvalidEventTypeDetailsDto:
      type: object
      properties:
        eventType:
          type: string
        productId:
          type: string
      required:
        - eventType
        - productId
    CustomerNotFoundDetailsDto:
      type: object
      properties:
        customerId:
          type: string
        branchId:
          type: string
        whenAt:
          type: string
        simulatedAt:
          type: string
      required:
        - customerId

````